/*
 * $Workfile$
 *
 * Current $Revision$ By $Author$
 *
 * $Modtime$
 *
 * Reverse Chronological Revision 
 *
 * $Log$
 *
*/


#ifndef __DBLAPI                        /* Prevent duplicate definition */
#define __DBLAPI

/******  Lower Level function prototypes for PenRight! Database Manager *****/
extern int DblAppendRecord (DATA4 *data);
extern int DblAppendInit (DATA4 *data, int use_memo_entries);
extern int DblCloseFiles (DATA4 *data);       
extern int DblCloseAllFiles (CODE4 *code_base);    
extern DATA4 *DblCreateFiles (CODE4 *code_base, char *name, FIELD4INFO *field_info,
                       TAG4INFO *tag_info);      
extern void DblInitialize (CODE4 *code_base);       
extern void DblInitUndo  (CODE4 *code_base);       
extern DATA4 *DblOpenFiles (CODE4 *code_base, char *name);        
extern void DblDeleteRecord (DATA4 *data);     
extern int DblDeletedRecord (DATA4 *data);     
extern int DblFlushAll (DATA4 *data);         
extern long DblRecordWidth (DATA4 *data);      
extern int DblFieldCount (DATA4 *data);       
extern void DblRecallRecord (DATA4 *data);     
extern int DblSeekRecord (DATA4 *data, char *ptr);       
extern int DblEndOfFile (DATA4 *data);        
extern FIELD4 * DblGetFieldPtr (DATA4 *data,char *field_name);      
extern void DblSelectTag (DATA4 *data, TAG4 *tag);        
extern TAG4 * DblGetTagPointer (DATA4 *data, char *tag_name);    
extern TAG4 * DblSelectedTag (DATA4 *data);      
extern int DblGoToRecord  (DATA4 *data, long record_number);      
extern int DblSkipRecord  (DATA4 *data, long num_records);      
extern int DblTopRecord (DATA4 *data);        
extern int DblBottomRecord (DATA4 *data);     
extern int DblPackMemoFile (DATA4 *data);     
extern int DblPackFiles (DATA4 *data);     
extern long DblRecordCount (DATA4 *data);      
extern long DblCurrentRecord (DATA4 *data);    
extern char * DblRecordBuffer  (DATA4 *data);    
extern int DblReindexFile (DATA4 *data);      
extern void DblAssignString (FIELD4 *field, char *ptr);     
extern void DblAssignChar (FIELD4 *field, int chr);       
extern void DblAssignDouble (FIELD4 *field, double value);     
extern void DblAssignInt (FIELD4 *field, int value);        
extern void DblAssignLong (FIELD4 *field, long value);       
extern void DblAssignBytes (FIELD4 *field, char *ptr, unsigned ptr_len);      
extern char * DblAssignPtr (FIELD4 *field);        
extern void DblBlankRecord (DATA4 *data);      
extern void DblBlankField (FIELD4 *field);       
extern DATA4 * DblGetDatabasePtr (CODE4 *cb, char *alias_name);          
extern int DblGetChar (FIELD4 *field);          
extern int DblGetDecimals (FIELD4 *field);      
extern double DblGetDouble (FIELD4 *field);        
extern int DblGetInteger (FIELD4 *field);       
extern unsigned DblGetFieldLength (FIELD4 *field);   
extern long DblGetLong (FIELD4 *field);          
extern char * DblGetFieldName (FIELD4 *field);     
extern unsigned DblCopyField (FIELD4 *field, char *mem_ptr, unsigned mem_len);        
extern char * DblGetString (FIELD4 *field);        
extern char * DblGetPointer (FIELD4 *field);       
extern int DblGetLogical (FIELD4 *field);       
extern int DblGetFieldType (FIELD4 *field);     
extern int DblCloseIndex (INDEX4 *index);       
extern INDEX4 * DblGetIndexFilePtr (DATA4 *data, char * file_name);
extern INDEX4 * DblCreateIndex (DATA4 *data, char * file_name, TAG4INFO *tag_info);      
extern INDEX4 * DblOpenIndex (DATA4 *data, char *file_name);        
extern int DblReindexIndex (INDEX4 *index);
extern TAG4 * DblGetTag (INDEX4 *index, char *tag_name);           
extern int DblAssignMemo (FIELD4 *field, char * ptr);       
extern int DblAssignMemoBytes (FIELD4 *field, char *ptr, unsigned ptr_len);  
extern unsigned DblGetMemoLength (FIELD4 *field);    
extern unsigned DblCopyMemo (FIELD4 *field, char *mem_ptr, unsigned len);         
extern char * DblGetMemoString (FIELD4 *field);    
extern char * DblGetMemoPointer (FIELD4 *field);   
extern QUERYSET DblInitQuery  (DATA4 *data);       
extern int DblSetQuery  (QUERYSET subset, char *expr);        
extern int DblQuerySkipEnable (QUERYSET subset, int do_enable);  
extern int DblFreeQuery (QUERYSET subset, int close_files);    
extern int DblQuerySkip (QUERYSET subset, long n);        
extern int DblQueryTop (QUERYSET subset);         
extern int DblQueryBottom (QUERYSET subset);      

/* locking functions */
extern int DblLockRecord (DATA4 *data);
extern int DblLockAllFiles (DATA4 *data);
extern int DblLockAppend (DATA4 *data);
extern int DblLockDataFile (DATA4 *data);
extern int DblLockIndexFiles (DATA4 *data);
extern int DblLockTestRecord (DATA4 *data);
extern int DblLockTestAppend (DATA4 *data);
extern int DblLockTestDataFile (DATA4 *data);
extern int DblLockTestIndexFiles (DATA4 *data);
extern int DblUnlockAllFiles (DATA4 *data);
extern int DblUnlockData (DATA4 *data);

/* memory optimization */
extern int DblOptimize (DATA4 *data, int optFlag);
extern int DblOptimizeStart (CODE4 *code_base);
extern int DblOptimizeSuspend (CODE4 *code_base);
extern int DblOptimizeWrite (DATA4 *data, int optFlag);

extern WORD DblGetErrorCode (int result);

extern void DblMemoryReset (void);       
#endif /* __DBLAPI */

