/*
 * $Workfile:   DBMAPI.H  $
 *
 * Current $Revision:   1.0  $ By $Author:   rahman  $
 *
 * $Modtime:   01 Jun 1993 17:36:16  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:\penright\vcs\sdk\database\cblib\dbmapi.h_v  $
 * 
 *    Rev 1.0   01 Jun 1993 17:36:38   rahman
 * Initial Revision
 *
*/


/*------------------------------------------------------------------------*/
/*                                                                        */
/*       DBMAPI.H                                                         */ 
/*                                                                        */
/*       PenRight! Database (Dbm) API header file. (included by penapi.h) */
/*                                                                        */
/*------------------------------------------------------------------------*/

#ifndef __DBMAPI                        /* Prevent duplicate definition */
#define __DBMAPI
#define PRMAX  80

/* relation pointer */
#define QUERYSET RELATE4*

#ifndef DBMLIB
#include <d4all.h>
#include <dblapi.h> 

#define CALLTYPE far
#define MAXMEMO 32767

#define DECLARE extern

#else
#define DECLARE

#endif  /* DBMLIB */

#ifdef DBSTUB
#include <dbstub.h>
#endif   /* DBSTUB */


/******  PenRight! Database data Types  ************************************/
enum ObjTypes {Field = 1, List, Control};         /* 0 is undefined */

typedef struct
{
     WORD formID;
     WORD objID;
     enum ObjTypes objtype;
     char DBfieldName[20];

} PR_DBMMAP, *PR_MAPPTR;

typedef struct 
{
          CODE4 *cb;
          char database[PRMAX];
          PR_DBMMAP *map;

} PR_DBMDATA, *PR_DBMPTR;


/******  PenRight! Database Error Codes  ************************************/
#define   eFormNotFound          9201
#define   eObjectNotFound        9202
#define   eTextNotFound          9203 

#define   eDbDataNotValid        9211
#define   eDbInvalidFile         9212
#define   eDbIndexFileInvalid    9213

#define   eDbFileLengthError     9215
#define   eDbFileLengthSetError  9216

#define   eDbRecordTooLong       9221
#define   eDbRemoveError         9222

#define   eDbInvalidField        9225
#define   eDbInvalidFieldType    9226

#define   eDbCreateError         9231
#define   eDbOpenError           9232
#define   eDbCloseError          9233
#define   eDbReadError           9234
#define   eDbWriteError          9235


#define   eDbSeekError           9241
#define   eDbSeekAfter           9242  
#define   eDbEndOfFile           9243
#define   eDbTopOfFile           9244

#define   eDbTagMissing          9251
#define   eDbTagInvalid          9252
#define   eDbTagUnique           9253

#define   eDbOutOfMemory         9261
#define   eDbUnexpectedResult    9262
#define   eDbNullSubset          9263


#define eDbExprCommaOrBracket    9271 
#define eDbExprNotComplete       9272
#define eDbExprDataFileNotFound  9273
#define eDbExprNotSameLength     9274
#define eDbExprNotConstant       9275
#define eDbExprNumParams         9276
#define eDbExprOverflow          9277
#define eDbExprInvalidTypeSub    9278
#define eDbExprUnrecognizedFunc  9279
#define eDbExprUnrecognizedOp    9280
#define eDbExprUnrecognizedVal   9281
#define eDbExprUnterminated      9282 


/*******  PenRight! Database API function prototypes  ***********************/
DECLARE void CALLTYPE DbmInitialize (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmCreate (PR_DBMPTR datamap, FIELD4INFO *fieldInfo, TAG4INFO *tagInfo);
DECLARE WORD CALLTYPE DbmOpen (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmClose (PR_DBMPTR datamap);

DECLARE WORD CALLTYPE DbmPutObject (PR_DBMPTR datamap, WORD formID, WORD objID);
DECLARE WORD CALLTYPE DbmSetObject (PR_DBMPTR datamap, WORD formID, WORD objID, BOOLEAN drawit);
DECLARE WORD CALLTYPE DbmGetRecord(PR_DBMPTR datamap, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmGetRecordToForm(PR_DBMPTR datamap, WORD formID);
DECLARE WORD CALLTYPE DbmUpdateRecord (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmFormUpdateRecord (PR_DBMPTR datamap, WORD formID);
DECLARE WORD CALLTYPE DbmStartNewRecord (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmSaveRecordAsNew (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmSaveNew (PR_DBMPTR datamap);

DECLARE WORD CALLTYPE DbmFindRecord (PR_DBMPTR datamap, char *searchstr, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmNext (PR_DBMPTR datamap, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmPrevious (PR_DBMPTR datamap, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmTop (PR_DBMPTR datamap, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmBottom (PR_DBMPTR datamap, WORD FormToDraw);
DECLARE void CALLTYPE DbmDeleteRecord (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmPackFiles (PR_DBMPTR datamap);
DECLARE WORD CALLTYPE DbmSetIndex (PR_DBMPTR datamap, char *tag);
DECLARE WORD CALLTYPE DbmFlush (PR_DBMPTR datamap);

DECLARE WORD CALLTYPE DbmSetQuery (PR_DBMPTR datamap, char *expr, QUERYSET *subset);
DECLARE WORD CALLTYPE DbmEndQuery (QUERYSET subset);
DECLARE WORD CALLTYPE DbmNextOfQuery (PR_DBMPTR datamap, QUERYSET subset, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmPreviousOfQuery (PR_DBMPTR datamap, QUERYSET subset, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmTopOfQuery (PR_DBMPTR datamap, QUERYSET subset, WORD FormToDraw);
DECLARE WORD CALLTYPE DbmBottomOfQuery (PR_DBMPTR datamap, QUERYSET subset, WORD FormToDraw);


#endif /* __DBMAPI */
