/*
 * $Workfile:   gpdcdr.h  $
 *
 * Current $Revision:   1.2  $ By $Author:   westerinen  $
 *
 * $Modtime:   17 Mar 1994 14:17:36  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:\penright\vcs\incs\gpdcdr.h_v  $
 * 
 *    Rev 1.2   29 Mar 1994 14:45:28   westerinen
 * 
 * Changed def of CDRENTRYTYPE to spec type of arg ...( )(WORD version);.
 * 
 *    Rev 1.1   03 Dec 1992 17:37:42   westerinen
 * added vcs header
 *
*/


/*--------------------------------------------------------*/
/*               Code Resource include file               */
/*--------------------------------------------------------*/

/*****************************************************************
  Following are declarations for the multiple entry point 
  code resource interface.
*****************************************************************/

#define eIncompatibleCodeResource 9300    /* version check error */

typedef void (far *(FUNCTABLETYPE[]))();

typedef FUNCTABLETYPE far *(far *CDRENTRYTYPE)(WORD version);

typedef struct 
{  
  unsigned char  popIP;
  unsigned char  pushCS;
  unsigned char  pushIP;
  unsigned char  jump;
  void           (far *vector)();
  unsigned char  retInstruction;
} THUNKTYPE;

typedef struct 
{  
  unsigned short    version;
  unsigned short    rscId;
  unsigned short    numFuncs;
  THUNKTYPE         far *thunkTable;
  CDRENTRYTYPE      entryPoint;
  FUNCTABLETYPE     far *cdrFcnTable;
} CDRINFOTYPE;


/****************************************************************
  CDR_FUNC is a macro that provides access to ALL functions provided 
  by a multiple entry point code resource, such as a pen driver, via a 
  pointer to the CDRINFOTYPE provided by the code resource interface, 
  such as the pen driver's DgtGetCdrInfoPtr function, and the (zero based)
  index of the function in the code resource's function table
****************************************************************/

#ifdef APIINTERNALCALLER
#define CALLCONVENTION cdecl
#else
#define CALLCONVENTION pascal      
#endif

typedef (CALLCONVENTION *pFcnType)();

#define CDR_FUNC(pCdrInfo,fcnIndex)                 \
{                                                   \
    pFcnType    pF;                                 \
    pF = (*((pCdrInfo)->cdrFcnTable))[(fcnIndex)];  \
    (*pF)();                                       \
}

