/****************************************************************************
*
*	Module Name: gpdctl.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			Replaced "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" for DOS.
*
****************************************************************************/

/*
 * $Workfile:   GPDCTL.H  $
 *
 * Current $Revision:   1.1  $ By $Author:   westerinen  $
 *
 * $Modtime:   03 Dec 1992 17:40:00  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:/penright/vcs/incs/gpdctl.h_v  $
 * 
 *    Rev 1.1   03 Dec 1992 17:40:04   westerinen
 * added vcs header
 *
*/


/*--------------------------------------------------------*/
/*                 Controls include file                  */
/*--------------------------------------------------------*/

/* define default delay values used in CtlSetRepeatRate */
#define DEF_CTLMINDELAY    100
#define DEF_CTLINITDELAY   250
#define DEF_CTLACCINTERVAL 100

enum controls { buttonCtrl = 0, checkboxCtrl, radioCtrl };

enum ctlFunctions 
{ ctlTerminate=-2,
  ctlInitialize=-1,
  ctlDraw=0,
  ctlDrawIndicator,
  ctlHighLight,
  ctlHandleEvent,
  ctlFreeInfo
};

typedef struct ctlStruct
{
  RECTANGLETYPE   rect;
  unsigned short  ctrlId;
  unsigned short  ctrlType;
  unsigned short  frameType;
  unsigned short  frameDiam;
  short           minValue;
  short           maxValue;
  short           value;
  BOOLEAN         enabled;
  unsigned char   visible;
  unsigned char   textJust;
  char far       *text;
  unsigned short  textLen;
  BOOLEAN         (far * customFunction) (unsigned short, 
                                      struct ctlStruct far *,
                                      EVENTTYPE far *,
                                      unsigned short far *);
  unsigned long   userData;
} CONTROLTYPE;


extern void _APICALL CtlDrawControl 
 (CONTROLTYPE far *pControl, BOOLEAN indicatorOnly);

extern void _APICALL CtlEnableControl 
 (CONTROLTYPE far *pControl, BOOLEAN enableIt);

extern void _APICALL CtlFreeControlInfo (CONTROLTYPE far *pControl);

extern BOOLEAN _APICALL CtlHandleEvent 
 (CONTROLTYPE far *pControl, EVENTTYPE far *pEvent, 
  unsigned short far *pError);

extern void _APICALL CtlInitControl
 (CONTROLTYPE far *pControl, unsigned short id, enum controls controlType,
  unsigned short frame, unsigned short cornerDiam, BOOLEAN justification,
  short initValue, short loValue, short hiValue, RECTANGLETYPE far *pRect,
  char far *pText, unsigned short textLength);

extern void _APICALL CtlSetControlValue
 (CONTROLTYPE far *pControl, short newValue);

extern void _APICALL CtlSetRepeatRate(unsigned short minDelay,
 unsigned short initDelay, unsigned short accelerationInterval);

extern void _APICALL CtlGetRepeatRate(unsigned short *minDelay,
 unsigned short *initDelay, unsigned short *accelerationInterval);
