/****************************************************************************
*
*	Module Name: gpddraw.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			ReplaceD "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" DOS.
*
*	1.02	07/03/95		FJL
*			Added constant BMPSIGNATURE.
*
****************************************************************************/

/*
 * $Workfile:   gpddraw.h  $
 *
 * Current $Revision:   1.2  $ By $Author:   westerinen  $
 *
 * $Modtime:   20 Apr 1993 16:25:26  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:\penright\vcs\incs\gpddraw.h_v  $
 * 
 *    Rev 1.2   20 Apr 1993 16:26:12   westerinen
 * Changed the definition of RSCCANVASPTR from a #define to a typedef.
 * 
 *    Rev 1.1   03 Dec 1992 17:41:44   westerinen
 * added vcs header
 *
*/


/*--------------------------------------------------------*/
/*                 Drawing include file                   */
/*--------------------------------------------------------*/

typedef struct
{
  unsigned short signature;           /* 'BI' - Bit Image */
  unsigned short offsetToBitImage;
  unsigned short width;
  unsigned short height;   
  unsigned short size;
  unsigned char  orientation;
  unsigned char  compression;
  unsigned char  bitPerPixel;
  unsigned char  unused [3];
  unsigned char  bitImage [1];
} RSCCANVASHDR;

typedef RSCCANVASHDR far *RSCCANVASPTR;    
#define CANVASSIGNATURE 0x4942
#define BMPSIGNATURE    0x4d42
#define CANVASHDRLEN    16
        /* note the bitImage field is not included in CANVASHDRLEN */


/* Routines to draw shapes or frames shapes */

extern BOOLEAN _APICALL WinTestPixel (short x, short y);

extern void _APICALL WinDrawPixel (short x, short y);

extern void _APICALL WinErasePixel (short x, short y);

extern void _APICALL WinInvertPixel (short x, short y);

extern void _APICALL WinPatternPixel (short x, short y);

#ifdef PRWIN
extern void _APICALL WinDrawInk (short x1, short y1, short x2, short y2);
extern COLORREF _APICALL WinGetPixel (short x, short y);
#endif

extern void _APICALL WinDrawLine (short x1, short y1, short x2, short y2);

extern void _APICALL WinEraseLine (short x1, short y1, short x2, short y2);

extern void _APICALL WinInvertLine (short x1, short y1, short x2, short y2);

extern void _APICALL WinPatternLine (short x1, short y1, short x2, short y2);

extern void _APICALL WinDrawRectangle
 (RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinEraseRectangle
 (RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinInvertRectangle
 (RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinPatternRectangle
 (RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinDrawRectangleFrame
 (unsigned short frame, RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinEraseRectangleFrame
 (unsigned short frame, RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinInvertRectangleFrame
 (unsigned short frame, RECTANGLETYPE far *r, unsigned short cornerDiam);

extern void _APICALL WinPatternRectangleFrame
 (unsigned short frame, RECTANGLETYPE far *r, unsigned short cornerDiam);

/* Routines relating to characters */

extern void _APICALL WinDrawChars
 (char far *chars, unsigned short len, short x, short y);

extern void _APICALL WinDrawGrayChars
 (char far *chars, unsigned short len, short x, short y);

extern void _APICALL WinEraseChars
 (char far *chars, unsigned short len, short x, short y);

extern void _APICALL WinInvertChars
 (char far *chars, unsigned short len, short x, short y);

extern void _APICALL WinPatternChars
 (char far *chars, unsigned short len, short x, short y);

/* Routines relating to canvas */

extern void _APICALL WinDrawCanvas 
 (unsigned short destTopLeftX, unsigned short destTopLeftY, 
  RSCCANVASPTR pCanvas, unsigned short far *error);


#ifdef PRWIN
extern void _APICALL WinDrawCanvasExtents
 (unsigned short destTopLeftX, unsigned short destTopLeftY, 
  unsigned short extentX, unsigned short extentY,
  RSCCANVASPTR pCanvas, unsigned short far *error);
#endif

void _APICALL WinRotateCanvas 
 (RSCCANVASPTR far *pCanvasPtr, unsigned char rotation, 
  unsigned short far *error);

void _APICALL WinSetCanvasCompression 
 (RSCCANVASPTR far *pCanvasPtr, BOOLEAN compress, unsigned short far *error);

void _APICALL WinSetCanvasOrientation 
 (RSCCANVASPTR far *pCanvasPtr, unsigned char orientation, 
  unsigned short far *error);

/* Routines to control patterns */

extern void _APICALL WinSetPattern (void far *pattern);

extern void _APICALL WinSetPatternXferMode (enum patternXferModes mode);

extern void _APICALL WinGetPattern (void far *pattern);

extern enum patternXferModes _APICALL WinGetPatternXferMode (void);

/* Pen width control for line functions */
extern unsigned short _APICALL WinSetPenWidth(unsigned short newWidth);
 
extern unsigned short _APICALL WinGetPenWidth(void);

