/****************************************************************************
*
*	Module Name: gpdfnt.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			ReplaceD "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" DOS.
*
****************************************************************************/

/*
 * $Workfile:   GPDFNT.H  $
 *
 * Current $Revision:   1.1  $ By $Author:   westerinen  $
 *
 * $Modtime:   03 Dec 1992 17:45:36  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:/penright/vcs/incs/gpdfnt.h_v  $
 * 
 *    Rev 1.1   03 Dec 1992 17:45:42   westerinen
 * added vcs header
 *
*/


/*--------------------------------------------------------*/
/*                   Fonts include file                   */
/*--------------------------------------------------------*/

typedef struct 
{
  unsigned short     version;
  unsigned short     fileSize;
  unsigned char      fileSizeHi;
  unsigned char      orientation;
  char               copyright [60];
  unsigned short     fontClass;
  unsigned short     pointSize;
  unsigned short     vertRes;
  unsigned short     horizRes;
  unsigned short     baseLine;
  unsigned short     intLead;
  unsigned short     extLead;
  unsigned char      italic;
  unsigned char      underline;
  unsigned char      strikeOut;
  unsigned short     weight;
  unsigned char      charSet;
  unsigned short     pixWidth;
  unsigned short     pixHeight;
  unsigned char      pitchFamily;
  unsigned short     avgWidth;
  unsigned short     maxWidth;
  char               firstChar;
  char               lastChar;
  char               defaultChar;
  char               breakChar;
  unsigned short     widthBytes;
  void far          *devName;
  char far          *faceName;
  void far          *bitsPointer;
  void far          *bitsData;
} FONTINFOTYPE;


#define FntGetFontPtr(fhdl) ((FONTINFOTYPE far *)((unsigned long)(fhdl)<<16))
#define FntGetFontHandle(fptr) ((unsigned short)((unsigned long)(fptr)>>16))

extern FONTINFOTYPE far * _APICALL FntLoadFont
 (char far *fntPathname, unsigned short far *error);

extern FONTINFOTYPE far * _APICALL FntSetFont (FONTINFOTYPE far *font);

extern BOOLEAN _APICALL FntProportionalFont (void);

extern short _APICALL FntBaseLine (void);

extern short _APICALL FntCharHeight (void);

extern short _APICALL FntLineHeight (void);

extern short _APICALL FntAverageCharWidth (void);

extern short _APICALL FntCharWidth (char ch);

extern short _APICALL FntCharsWidth (char far *chars, unsigned short len);

extern FONTINFOTYPE far * _APICALL FntGetBuiltInFont (void);

extern unsigned short _APICALL FntSetFontHandle (unsigned short handle);
