/****************************************************************************
*
*	Module Name: gpdfrm.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			ReplaceD "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" DOS.
*
****************************************************************************/

/*
 * $Workfile:   gpdfrm.h  $
 *
 * Current $Revision:   1.2  $ By $Author:   tharakan  $
 *
 * $Modtime:   13 May 1994 14:35:56  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:\penright\vcs\incs\gpdfrm.h_v  $
 * 
 *    Rev 1.2   13 May 1994 18:10:56   tharakan
 * Added prototype for FrmAllocateFormID
 * 
 *    Rev 1.1   03 Dec 1992 17:46:16   westerinen
 * added vcs header
 *
*/


/*----------------------------------------------------------*/
/*                     Forms include file                   */
/*----------------------------------------------------------*/

/* graphic types */
#define GFXTEXT        0
#define GFXLINE        1
#define GFXRECTANGLE   2
#define GFXFRAME       3
#define GFXDYNAMICTEXT 4

/* macros for access to field [index], control [index], ... */
/*  pForm = pointer to FormType                             */
/*  index = index of the field (NOTE: zero based value)     */
#define PTR_TO_FRMFIELD(pForm,index)   (*((pForm)->field+(index)))
#define PTR_TO_FRMCONTROL(pForm,index) (*((pForm)->control+(index)))
#define PTR_TO_FRMLIST(pForm,index)    (*((pForm)->list+(index)))
#define PTR_TO_FRMCANVAS(pForm,index)  (*((pForm)->canvas+(index)))
#define PTR_TO_FRMGRAPHIC(pForm,index) (*((pForm)->graphic+(index)))

/* Field triggers */
/* access FRMFIELDTYPE.trigger as an unsigned short value */
#define DOUBLECLICKTRIGGER          0
#define NEVERTRIGGER                1
#define FLDENTERTRIGGER             3
#define FLDCHANGEDTRIGGER           5
#define FLDKEYTRIGGER               9

/* access FRMFIELDTYPE.trigger as a bit field value */
typedef struct triggerBits
{
  unsigned  doubleClickDisable:  1;
  unsigned  fldEnterEnable:      1;
  unsigned  fldChangedEnable:    1;
  unsigned  fldKeyEnable:        1;
  unsigned  reserved:            12;
} FLDTRIGGERBITS;

typedef struct 
{
  BOOLEAN            required;
  unsigned short     reserved0;
  BOOLEAN            (far * triggerFunction)(unsigned short,
                                         FIELDTYPE far *,
                                         EVENTTYPE far *,
                                         unsigned short far *);
#if defined(TRIGGERBTFLD)
  FLDTRIGGERBITS     trigger;
#else
  unsigned short     trigger;
#endif
  unsigned short     reserved1;
  unsigned char      reserved2;
  FIELDTYPE          theField;
} FRMFIELDTYPE;

typedef struct 
{
  unsigned short     textStrIndex;
  unsigned short     group;
  unsigned short     codeResourceId;
  unsigned char      reserved1;
  unsigned short     reserved2;
  unsigned char      reserved3;
  CONTROLTYPE        theControl;
  unsigned short     font;
} FRMCONTROLTYPE;

typedef struct 
{
  unsigned short     userID;
  unsigned short     textStrIndex;
  unsigned char      gfxType;
  unsigned char      pattern;
  unsigned char      transferMode;
  unsigned short     frameType;
  unsigned short     font;
  RECTANGLETYPE      rect;
} FRMGRAPHICTYPE;
     
typedef struct 
{
  unsigned short     textStrIndex;
  unsigned short     titleStrIndex;
  LISTTYPE           theList;
} FRMLISTTYPE;
     
typedef struct 
{
  unsigned short     userID;
  RECTANGLETYPE      rect;
  unsigned short     canvasRscID;
  RSCCANVASPTR       pCanvas;
} FRMCANVASTYPE;

typedef struct 
{
   BOOLEAN           enabled;
   POINTTYPE         place;
   short             height;
} FRMINSPTTYPE;

typedef struct 
{
  RECTANGLETYPE       displayRect;
  unsigned short      currentField;
  unsigned short      numFields;
  unsigned short      numControls;
  unsigned short      numGraphics;
  unsigned short      numLists;
  unsigned short      numCanvases;
  FRMFIELDTYPE        (far *field) [1];
  FRMCONTROLTYPE      (far *control) [1];
  FRMGRAPHICTYPE      (far *graphic) [1];
  FRMLISTTYPE         (far *list) [1];
  FRMCANVASTYPE       (far *canvas) [1];
  RSCSTRINGTYPE far  *staticStrs;
  BOOLEAN             highlightOn;
  BOOLEAN             highlightCurFld;
  BOOLEAN             errorPending;
  BOOLEAN             formChanged;
  BOOLEAN             formVisible;
  BOOLEAN             modalForm;
  BOOLEAN             fldChangedPending;
  FRMINSPTTYPE        insertPt;
  unsigned short      bitsOfForm;
  unsigned short      frameType;
  unsigned short      staticTextFont;
  unsigned short      fieldFont;
  unsigned short      windowIdOfForm;
  unsigned short      titleStrIndex;
  unsigned short      currentTextField;
  unsigned short      formRscId;
  unsigned short      reserved1;
  unsigned long       userData;
} FORMTYPE;

typedef FORMTYPE far *FORMPTR;

#ifdef PRWIN
typedef void (FAR PASCAL _export * FPFRMCB) (WORD);
#endif

extern unsigned short _APICALL FrmInitForm
 (unsigned short rscID, unsigned short far *error);

extern void _APICALL FrmDisposeForm
 (unsigned short far *winHandle, unsigned short far *error);

extern void _APICALL FrmDrawForm
 (unsigned short winHandle, BOOLEAN drawForeground, BOOLEAN drawBackground);

extern void _APICALL FrmEraseForm (unsigned short winHandle);

extern void _APICALL FrmSetActiveForm (unsigned short winHandle);

extern BOOLEAN _APICALL FrmFormChanged (unsigned short winHandle);

extern void _APICALL FrmResetChangedState (unsigned short winHandle);

extern unsigned short _APICALL FrmGetControlIndex
 (unsigned short winHandle, unsigned short controlID);

extern unsigned short _APICALL FrmGetFieldIndex
 (unsigned short winHandle, unsigned short fieldID);

extern unsigned short _APICALL FrmGetListIndex
 (unsigned short winHandle, unsigned short listID);

extern CONTROLTYPE far * _APICALL FrmGetControlPtr
 (unsigned short winHandle, unsigned short controlIndex);

extern FIELDTYPE far * _APICALL FrmGetFieldPtr 
 (unsigned short winHandle, unsigned short fieldIndex);

extern LISTTYPE far * _APICALL FrmGetListPtr 
 (unsigned short winHandle, unsigned short listIndex);

extern FORMTYPE far * _APICALL FrmGetFormPtr (unsigned short winHandle);

extern unsigned short _APICALL FrmGetCurrentField (unsigned short winHandle);
            
extern void _APICALL FrmSetCurrentField
 (unsigned short winHandle, unsigned short fieldIndex);

extern short _APICALL FrmGetControlValue
 (unsigned short winHandle, unsigned short controlIndex);

extern void _APICALL FrmSetControlValue
 (unsigned short winHandle, unsigned short controlIndex, short newValue);

extern unsigned short _APICALL FrmGetListChoice
 (unsigned short winHandle, unsigned short listIndex);

extern void _APICALL FrmSetListChoice
 (unsigned short winHandle, unsigned short listIndex, unsigned short itemNum);

extern unsigned short _APICALL FrmGetFieldValue
 (unsigned short winHandle, unsigned short fieldIndex,
  enum fieldValueType valueType, union FIELDVALUERECORD far *value);

extern unsigned short _APICALL FrmSetFieldValue
 (unsigned short winHandle, unsigned short fieldIndex,
  enum fieldValueType valueType, union FIELDVALUERECORD far *newValue);

extern unsigned short _APICALL FrmGetNumberOfControls (unsigned short winHandle);

extern unsigned short _APICALL FrmGetNumberOfFields (unsigned short winHandle);

extern unsigned short _APICALL FrmGetNumberOfLists (unsigned short winHandle);

extern BOOLEAN _APICALL FrmFieldsPassEditChecks
 (unsigned short winHandle, unsigned short far *badField,
  unsigned short far *error);

extern BOOLEAN _APICALL FrmHandleEvent
 (EVENTTYPE far *event, unsigned short far *error);

extern void _APICALL FrmGetFormFrameRect
 (unsigned short winHandle, RECTANGLETYPE far *r);

extern unsigned short _APICALL FrmGetWindowHandle (unsigned short formRscID);

extern unsigned short _APICALL FrmGetFormId (unsigned short winHandle);

extern unsigned short _APICALL FrmGetGroupChoice 
 (unsigned short winHandle, unsigned short groupNum);

extern WORD _APICALL FrmGetControlId (WORD winHandle, WORD ctlIndex);

extern WORD _APICALL FrmGetFieldId (WORD winHandle, WORD fieldIndex);

extern WORD _APICALL FrmGetListId (WORD winHandle, WORD lstIndex);

extern void _APICALL FrmEnableInsPt (WORD winHandle, BOOLEAN enableIt);

extern FORMTYPE far * _APICALL FrmAllocateForm 
 (WORD numFields, WORD numControls, WORD numGraphics, WORD numLists, 
  WORD numCanvases, WORD far *error);

extern FORMTYPE far * _APICALL FrmAllocateFormID
 (WORD numFields, WORD numControls, WORD numGraphics, WORD numLists, 
  WORD numCanvases, WORD formId, WORD far *error);

#ifdef PRWIN
extern void _APICALL FrmSetCallBack(FPFRMCB lpfnCallBack);
#endif
