/****************************************************************************
*
*	Module Name: gpdhwp.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			ReplaceD "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" DOS.
*
****************************************************************************/

/*
 * $Workfile:   GPDHWP.H  $
 *
 * Current $Revision:   1.1  $ By $Author:   westerinen  $
 *
 * $Modtime:   03 Dec 1992 17:46:48  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:/penright/vcs/incs/gpdhwp.h_v  $
 * 
 *    Rev 1.1   03 Dec 1992 17:46:52   westerinen
 * added vcs header
 *
*/


/*----------------------------------------------------------*/
/*            Handwriting Processing include file           */
/*----------------------------------------------------------*/

/*---  constants  ---*/

#define NO_TARGET_FIELD_FOUND  65535

/*---  functions  ---*/

extern BOOLEAN _APICALL HwpCaptureFirstStroke 
 (EVENTTYPE far *pEvent, TIMETYPE far *pPenUpTime, unsigned short far *pError);

extern BOOLEAN _APICALL HwpCaptureStrokes 
 (EVENTTYPE far *pEvent, unsigned short far *pError);

extern void _APICALL HwpDislocate (void);

extern int _APICALL HwpRegisterTask(void);
extern void _APICALL HwpUnregisterTask(void);

extern void _APICALL HwpEnableRecognition (BOOLEAN enableIt);

extern DISPLAYMASKTYPE far * _APICALL HwpGetDefaultRecognitionMask 
 (unsigned char fldDataType);

extern void _APICALL HwpGetHwrPtrs 
 (PPTSTYPE far * pPts, PSTROKESTYPE far * pStrokes, 
  PMATCHTEXTTYPE far * pChars);

extern void _APICALL HwpGetTimeouts 
 (unsigned short far * pMinPenUp, unsigned short far * pMaxPenUp);

extern BOOLEAN _APICALL HwpHandleEvent
 (EVENTTYPE far *pEvent, unsigned short far *pError);

extern BOOLEAN _APICALL HwpHandleGesture 
 (EVENTTYPE far *pEvent, unsigned short far *pError);

extern BOOLEAN _APICALL HwpHandleHandwriting
 (EVENTTYPE far *pEvent, unsigned short far *pError);

extern unsigned short _APICALL HwpLocate (void);

extern BOOLEAN _APICALL HwpRecognitionEnabled (void);

extern BOOLEAN _APICALL HwpRecognizeGesture
 (EVENTTYPE far *pEvent, unsigned short far *pGestureCode, 
  unsigned short far *pTargetFld, unsigned short far *pError);

extern BOOLEAN _APICALL HwpRecognizeHandwriting
 (EVENTTYPE far *pEvent, short far *pLastStrokeInGroup, 
  char far * (far *pText), unsigned short far *pTextLen, 
  unsigned short far *pError);

extern unsigned short _APICALL HwpResetHWRBuffers
 (unsigned short mxPts, unsigned short mxStrokes, unsigned short mxChars);

extern void _APICALL HwpSetTimeouts 
 (unsigned short minPenUp, unsigned short maxPenUp);

/*--- not currently available ---
extern unsigned short _APICALL HwpInitialize 
 (unsigned short mxPts, unsigned short mxStrokes, 
  unsigned short mxChars, unsigned short templateID);

extern void _APICALL HwpTerminate (void);

extern void _APICALL HwpSetMatchButton 
 (unsigned short winHandle, unsigned short controlIndex);
---*/

/*--- no longer available ---
extern BOOLEAN _APICALL HwpCapture
 (EVENTTYPE far *pEvent, unsigned short far *pFieldNumber, 
  unsigned short far *pEventCause, unsigned short far *pError);

extern BOOLEAN _APICALL HwpPlacement
 (EVENTTYPE far *pEvent, unsigned short far *pFieldNumber, 
  unsigned short far *pEventCause, unsigned short far *pError);
---*/
