/****************************************************************************
*
*	Module Name: gpdhwr.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			Replaced "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" DOS.
*
****************************************************************************/

/*
 * $Workfile:   GPDHWR.H  $
 *
 * Current $Revision:   1.1  $ By $Author:   westerinen  $
 *
 * $Modtime:   03 Dec 1992 17:47:48  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:/penright/vcs/incs/gpdhwr.h_v  $
 * 
 *    Rev 1.1   03 Dec 1992 17:47:54   westerinen
 * added vcs header
 *
*/


/*--------------------------------------------------------*/
/*         Handwriting Recognition include file           */
/*--------------------------------------------------------*/

#define HWRDATARSCID       -50
#define MAXMATCHESPERCHAR  4

typedef struct 
{
  unsigned short     maxPts;
  unsigned short     numPts;
  ABSRECTTYPE        ptsRect;
  POINTTYPE          pt [1];
} PTSTYPE;

typedef struct 
{
  unsigned short     ptStartIndex;
  unsigned short     numPtsInStroke;
  ABSRECTTYPE        strokeRect;
} STROKEINFOTYPE;

typedef struct 
{
  unsigned short     maxStrokes;
  unsigned short     numStrokes;
  STROKEINFOTYPE     stroke [1];
} STROKESTYPE;

typedef struct 
{
  unsigned short     chValue;
  unsigned char      certainty;
  unsigned char      reserved;
} MATCHCHARTYPE;

typedef struct 
{
  unsigned short     numMatchesThisChar;
  ABSRECTTYPE        chRect;
  unsigned short     firstStrokeThisChar;
  unsigned short     lastStrokeThisChar;
  unsigned short     reserved [2];
  MATCHCHARTYPE      ch [MAXMATCHESPERCHAR];
} MATCHCHARINFOTYPE;

typedef struct 
{
  unsigned short     maxTextChars;
  unsigned short     numTextChars;
  MATCHCHARINFOTYPE  chInfo [1];
} MATCHTEXTTYPE;


typedef PTSTYPE far *PPTSTYPE;
typedef STROKESTYPE far *PSTROKESTYPE;
typedef MATCHTEXTTYPE far *PMATCHTEXTTYPE;


extern void _APICALL HwrAddPoint 
 (short x, short y, BOOLEAN penDown, BOOLEAN concat);

extern void _APICALL HwrEnableChars 
 (unsigned short lowNum, unsigned short highNum, BOOLEAN enable);

extern void _APICALL HwrFilterData 
 (unsigned short firstStrokeIndex, unsigned short lastStrokeIndex);

extern void _APICALL HwrGetData 
 (void far * (far *pTheData), unsigned short far *len);

extern void _APICALL HwrInitialize (unsigned short ptsPerInch);

extern void _APICALL HwrMatchChars 
 (PMATCHTEXTTYPE matchText, 
  unsigned short firstStrokeIndex, unsigned short lastStrokeIndex);

extern void _APICALL HwrMatchOneChar 
 (PMATCHTEXTTYPE matchText, 
  unsigned short firstStrokeIndex, unsigned short lastStrokeIndex);

extern void _APICALL HwrSetData (void far *theData);

extern void _APICALL HwrStartChar 
 (PPTSTYPE ptsBuffer, PSTROKESTYPE strokesBuffer);

/*--- not currently available ---
extern void _APICALL HwrLearnChar 
 (unsigned short ch, PTSTYPE far *pts, STROKESTYPE far *strokes, 
  unsigned short startStroke, unsigned short numStrokes, 
  unsigned short far *error);

extern void _APICALL HwrForgetChar (unsigned short ch);
---*/

