/****************************************************************************
*
*	Module Name: gpdlst.h
*
*	Description:
*
*	Revision History:
*	0.6	02/10/95		FJL
*			Replaced "pascal" in all API function prototypes with _APICALL
*			which is defined as "pascal far" for Windows and "pascal" for DOS.
*
****************************************************************************/

/*
 * $Workfile:   GPDLST.H  $
 *
 * Current $Revision:   1.1  $ By $Author:   westerinen  $
 *
 * $Modtime:   03 Dec 1992 17:51:46  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:/penright/vcs/incs/gpdlst.h_v  $
 * 
 *    Rev 1.1   03 Dec 1992 17:51:50   westerinen
 * added vcs header
 *
*/


/*---------------------------------------------------------*/
/*                    List include file                    */
/*---------------------------------------------------------*/

#define LSTTITLEMAR 5
#define LSTLINEGAP  2

/* define default values for list scroll rate */
#define DEF_LSTMINDELAY    0
#define DEF_LSTINITDELAY   250
#define DEF_LSTACCINTERVAL 35

typedef struct 
{
  char far       *ptr;
  unsigned short  length;
} TEXTPTRTYPE;

typedef struct 
{
  unsigned short  listId;
  RECTANGLETYPE   rect;
  unsigned short  frameType;
  BOOLEAN         visible;
  unsigned short  visibleItems;
  unsigned short  numItems;
  unsigned short  curItem;
  unsigned short  topItem;
  unsigned short  firstItem;
  unsigned short  lastItem;
  unsigned short  font;
  char far       *title;
  unsigned short  titleLen;
  char far       *choices;
  unsigned short  choicesLen;
  TEXTPTRTYPE     (far *pTextPtrs) [1];
  void far       *userData;
} LISTTYPE;


extern void _APICALL LstDrawList (LISTTYPE far *list);

extern void _APICALL LstEraseList (LISTTYPE far *list);

extern unsigned short _APICALL LstFindItem
 (LISTTYPE far *list, char far *pText, unsigned short len);

extern void _APICALL LstFreeListMemory (LISTTYPE far *list);

extern void _APICALL LstGetChoiceText
 (LISTTYPE far *list, unsigned short itemNum, 
  char far * (far *pText), unsigned short far *len);

extern unsigned short _APICALL LstGetCurrentChoice (LISTTYPE far *list);

extern void _APICALL LstGetListFrameRect 
 (LISTTYPE far *list, RECTANGLETYPE far *rect);

extern BOOLEAN _APICALL LstHandleEvent
 (LISTTYPE far *list, EVENTTYPE far *event, unsigned short far *error);

extern void _APICALL LstInitList 
 (LISTTYPE far *list, RECTANGLETYPE far *rect, unsigned short listId, 
  unsigned short numItems, unsigned short frame, char far *title, 
  unsigned short titleLen);

extern void _APICALL LstSetCurrentChoice
 (LISTTYPE far *list, unsigned short itemNum);

extern void _APICALL LstSetListChoices 
 (LISTTYPE far *list, char far *choices, unsigned short choicesLen, 
  char delim, unsigned short far *error);

extern void _APICALL LstSetScrollRate 
 (unsigned short minDelay, unsigned short initDelay, 
  unsigned short accelerationInterval);

extern void _APICALL LstScrollList
 (LISTTYPE far *list, unsigned short distance, enum directions direction);

