/****************************************************************************
*
*	Module Name: penright.h
*
*	Description:
*
*	Revision History:
*	0.5	11/23/94		FJL
*			Made the following changes:
*			1.	Added check for new identifier, PRWIN, which used to conditionally
*				compile for use with the Windows run-time. If defined, the
*				S4WINDOWS identifer is defined. This identifier is used by the
*				data base include files for Windows conditional compilation.
*
****************************************************************************/

/*----------------------------------------------------------*/
/* PenRight! Pro Application Program Interface include file */
/*----------------------------------------------------------*/

/*----------------------------------------------------------*/
/*                     IMPORTANT NOTICE                     */
/*                                                          */
/*  The data structures in the following include files      */
/*  require packing to the nearest byte.  This is not       */
/*  necessarily the default used by your compiler!          */
/*                                                          */
/*  For Microsoft C 5.0 this is accomplished by use of the  */
/*  /Zp1 switch on the compiler command line or the         */
/*  #pragma pack(1) directive within the source code.       */
/*                                                          */
/*  For Turbo C 2.0 the compiler should be installed by     */
/*  TCINST with Alignment set to byte-aligning.  This       */
/*  option is found within the Code Generation portion of   */
/*  the Compiler menu.                                      */
/*----------------------------------------------------------*/

#ifndef __penright_h
#define __penright_h

#ifdef PRWIN
#ifndef S4WINDOWS
#define S4WINDOWS
#endif
#endif

#define __IN_PENRIGHT_H

#ifdef __cplusplus
/*  for Borland C++  */
extern "C" {
#endif

#include <penapi.h>
#include <verbs.h>
#include <dcmapi.h>
#include <dbmapi.h> 

#ifdef __cplusplus
}
#endif

#undef  __IN_PENRIGHT_H

#endif  /* __penright_h */

