/****************************************************************************
*
*	Module Name: verbs.h
*
*	Description:
*
*	Revision History:
*
*	0.6	02/10/95		FJL
*			Added "far" to pointers returned by various functions.
*
****************************************************************************/

/*
 * $Workfile:   verbs.h  $
 *
 * Current $Revision:   1.8  $ By $Author:   rahman  $
 *
 * $Modtime:   05 Jan 1994 16:03:50  $
 *
 * Reverse Chronological Revision 
 *
 * $Log:   H:\penright\vcs\incs\verbs.h_v  $
 * 
 *    Rev 1.8   05 Jan 1994 16:04:04   rahman
 * The close bracket was missing for cplusplus.
 * 
 *    Rev 1.7   03 Jun 1993 08:28:28   rahman
 * Added check for C++.
 *
*/


/*------------------------------------------------------------------------*/
/*                                                                        */
/*       VERBS.H                                                          */
/*                                                                        */
/*       PenRight! Verbs header file. (included by penright.h)            */
/*                                                                        */
/*------------------------------------------------------------------------*/

#ifndef __PRVERBS                        /* Prevent duplicate definition */
#define __PRVERBS

#ifndef SDK

/* PR3.5: Include user header file */
#include <usrverbs.h> 

/* event types */
#define appEnterEvent         128
#define appExitEvent          129
#define frmCreateEvent        130
#define frmInitEvent          131
#define frmOpenEvent          132
#define frmUpdateEvent        133
#define frmCloseEvent         134
#define frmDisposeEvent       135


/***************************************************************************/
/****** PenRight! verbs prototype definitions ******************************/
/***************************************************************************/

#ifndef __IN_PENRIGHT_H
#ifdef  __cplusplus
extern "C"
{
#endif  /* __cplusplus */
#endif  /* __IN_PENRIGHT_H */ 

extern void ClearStack (WORD formId); 

extern void CloseForm (WORD formId);

extern BOOLEAN DisplayNotice (char * msg, char * confirmStr, char * cancelStr);

extern void DrawControl (WORD formId, WORD controlId);

extern void DrawField (WORD formId, WORD fieldId);

extern void DrawForm (WORD formId);

extern void DrawGraphic (WORD formId, WORD gfxId);

extern void DrawList (WORD formId, WORD listId);

extern void EnableControl (WORD formId, WORD ctlId, BOOLEAN enableIt);

extern void EnableField (WORD formId, WORD fieldId, BOOLEAN enableIt);

extern void EnableGraphic (WORD formId, WORD gfxId, BOOLEAN enableIt);

extern void EnableInsPt (WORD frmRscId, BOOLEAN enableIt);

extern void EraseControl (WORD formId, WORD controlId);

extern void EraseDisplay (void);

extern void EraseField (WORD formId, WORD fieldId);

extern void EraseForm (WORD formId);

extern void EraseList (WORD formId, WORD listId);

extern BOOLEAN FormEnabled (WORD formId);

extern void FreeForm (WORD formId);

extern WORD GetActiveControl (WORD formId, WORD group);

extern WORD GetActiveForm (void);

extern WORD GetControlId (WORD formId, WORD ctlIndex);

extern WORD GetControlIndex (WORD formId, WORD ctlId);

extern CONTROLTYPE far * GetControlPtr (WORD formId, WORD cltId);

extern short GetControlValue (WORD formId, WORD ctlId);

extern WORD GetCurrentFieldId (WORD formId);

extern WORD GetErrorCode (void);

extern WORD GetEventsObject (EVENTTYPE * event);

extern short GetFieldInteger (WORD formId, WORD fieldId);

extern FIELDTYPE far * GetFieldPtr (WORD formId, WORD fieldId);

extern char far * GetFieldString (WORD formId, WORD fieldId);

extern FORMTYPE far * GetFormPtr (WORD formId);

extern FRMGRAPHICTYPE far * GetGraphicPtr (WORD formId, WORD gfxId);

extern WORD GetListChoice (WORD formId, WORD listId);

extern char far * GetListChoiceString (WORD formId, WORD listId);

extern LISTTYPE far * GetListPtr (WORD formId, WORD listId);

extern char far * GetRscString (WORD rscId, WORD strIndex);

extern WINDOWINFOTYPE far * GetWindowPtr (WORD formId);

extern void GotoForm (WORD formId);

extern void InitStack (void);

extern void InitForm (WORD formId);

extern BOOLEAN InsPtInField (WORD formId, WORD fieldId);

extern void OpenForm (WORD frmRscId);

extern WORD PopForm (void);

extern void PopupForm (WORD formId);

extern WORD PostEvent (WORD type, WORD numDataItems, ...);

extern void PushForm (WORD formId);

extern char far *ReadFile (char *path);

extern void ReturnFromForm (void);

extern void SetControlValue (WORD formId, WORD ctlId, WORD value);

extern void SetDisplayOrientation (int orientation);

extern void SetFieldInteger (WORD formId, WORD fieldId, short num);

extern void SetFieldProperty (WORD formId, WORD fldId, WORD mask, WORD value);

extern void SetFieldString (WORD formId, WORD fieldId, char * text);

extern void SetListChoice (WORD formId, WORD listId, WORD itemNum);

extern void SetListChoiceString (WORD formId, WORD listId, char * itemStr);

extern void Stop (void);

extern void WriteFile (char *path, char * str);

extern void Print (char * str);

#ifndef __IN_PENRIGHT_H
#ifdef  __cplusplus
}
#endif  /* __cplusplus */
#endif  /* __IN_PENRIGHT_H */


#endif SDK

#endif /* __PRVERBS */

