#############################################################
#
#  Name: house.mak
#
#  Description: BorlandC make file for house DOS project
#
#############################################################


#------------------------------------------------------#
#                  Directory macro                     #
#------------------------------------------------------#

# The following macro specifies the directory where
# the object files should be stored.

ObjDir     = 

# The following macro specifies the directory where
# the include files are stored.

IncludeDir = j:\penrdpmi\inc;o:\bor300\include;c:\run286\inc\\ 


# The following macro specifies the directory where
# the PenRight! libraries are stored.

PRLib     = c:\penright\libs\\

# The following macro specifies the directory where
# the BorlandC libraries are stored.

CLib       = o:\bor300\lib\


#------------------------------------------------------#
#  Borland C compiler options:                         #
#    -I  : Include file directory                      #
#    -O  : Optimize jumps                              #
#    -S  : Produce assembly output                     #
#    -Z  : Optimize register usage                     #
#    -c  : Compile only, don't link                    #
#    -f  : Floating point emulator                     #
#    -mc : Compact memory model                        #
#    -n  : Output file directory                       #
#    -p  : Pascal calls                                #
#    -r  : Register variables                          #
#    -u  : Underscores on externs                      #
#    -v  : Source level debugging                      #
#    -w  : Enable all warnings                         #
#------------------------------------------------------#
CompileOpts = bcc -v -c -ml -N- -I$(IncludeDir)


#------------------------------------------------------#
# Borland linker options:                              #
#    /m : map file with publics                        #
#    /x : no map file at all                           #
#    /i : initialize all segments                      #
#    /l : include source line numbers                  #
#    /s : detailed map of segments                     #
#    /n : no default libraries                         #
#    /d : warn if duplicate symbols in libraries       #
#    /c : lower case significant in symbols            #
#    /3 : enable 32-bit processing                     #
#    /v : include full symbolic debug information      #
#    /e : ignore Extended Dictionary                   #
#    /t : create COM file                              #
#------------------------------------------------------#
LinkOpts = bcc286 -v -lm


#------------------------------------------------------#
#                     FormBuild                        #
#------------------------------------------------------#
.frm.rsc:
	FrmBuild $< /k


#------------------------------------------------------#
#                        Link                          #
#------------------------------------------------------#
house.Exe :    \
    house.rsc  \
    $(ObjDir)house.obj
	  $(LinkOpts) @&&!
	  $(ObjDir)house.obj
	  $(PRLib)penrapi.lib\
     $(PRLib)penrhw.lib\
     $(PRLib)penralt.lib\
     $(PRLib)penrkbd.lib\
	  $(PRLib)penrvrb.lib
!
#------------------------------------------------------#
#                       Compile                        #
#------------------------------------------------------#
$(ObjDir)house.obj :  \
    house.c    \
    house.h
	$(CompileOpts) $&.c


#------------------------------------------------------#
#                    Build resources                   #
#------------------------------------------------------#
house.rsc :    \
   kitchen1.rsc   \
   kitchen2.rsc   \
   \PENRIGHT\FONTS\PALOALTO.FNT   \
   \PENRIGHT\FONTS\PALO12.FNT   \
   \PENRIGHT\FONTS\FREMONT.FNT
	RscBuild house.res
