#############################################################
#
#  Name: test.mak
#
#  Description: BorlandC make file for test DOS project
#
#############################################################


#------------------------------------------------------#
#                  Directory macro                     #
#------------------------------------------------------#

# The following macro specifies the directory where
# the object files should be stored.

ObjDir     = 

# The following macro specifies the directory where
# the include files are stored.

IncludeDir = c:\penright\incs;o:\bor300\include;c:\run286\inc\\ 

# The following macro specifies the directory where
# the PenRight! libraries are stored.

PRLib     = c:\penright\libs\\

# The following macro specifies the directory where
# the BorlandC libraries are stored.

CLib       = o:\bor300\lib\


#------------------------------------------------------#
#  Borland C compiler options:                         #
#    -I  : Include file directory                      #
#    -O  : Optimize jumps                              #
#    -S  : Produce assembly output                     #
#    -Z  : Optimize register usage                     #
#    -c  : Compile only, don't link                    #
#    -f  : Floating point emulator                     #
#    -mc : Compact memory model                        #
#    -n  : Output file directory                       #
#    -p  : Pascal calls                                #
#    -r  : Register variables                          #
#    -u  : Underscores on externs                      #
#    -v  : Source level debugging                      #
#    -w  : Enable all warnings                         #
#------------------------------------------------------#
CompileOpts = bcc -v -c -ml -N- -I$(IncludeDir)


#------------------------------------------------------#
# Borland linker options:                              #
#    /m : map file with publics                        #
#    /x : no map file at all                           #
#    /i : initialize all segments                      #
#    /l : include source line numbers                  #
#    /s : detailed map of segments                     #
#    /n : no default libraries                         #
#    /d : warn if duplicate symbols in libraries       #
#    /c : lower case significant in symbols            #
#    /3 : enable 32-bit processing                     #
#    /v : include full symbolic debug information      #
#    /e : ignore Extended Dictionary                   #
#    /t : create COM file                              #
#------------------------------------------------------#
LinkOpts = bcc286 -v -lm


#------------------------------------------------------#
#                     FormBuild                        #
#------------------------------------------------------#
.frm.rsc:
	FrmBuild $< /k


#------------------------------------------------------#
#                        Link                          #
#------------------------------------------------------#
test.Exe :    \
    test.rsc  \
    $(ObjDir)test.obj
	  $(LinkOpts) @&&!
	  $(ObjDir)test.obj
	  $(PRLib)prpapi.lib\
     $(PRLib)prphwp.lib\
     $(PRLib)prpalt.lib\
     $(PRLib)prpkbd.lib\
	  $(PRLib)prpvrb.lib
!
#------------------------------------------------------#
#                       Compile                        #
#------------------------------------------------------#
$(ObjDir)test.obj :  \
    test.c    \
    test.h
	$(CompileOpts) $&.c

#------------------------------------------------------#
#                    Build resources                   #
#------------------------------------------------------#
test.rsc :    \
   form1.rsc   \
   \PENRIGHT\FONTS\PALO16.FNT   \
   \PENRIGHT\FONTS\VSHLV10.FNT   \
   \PENRIGHT\FONTS\PALO12.FNT
	RscBuild test.res -x

